"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Install = exports.Run = void 0;
const shelljs_1 = require("shelljs");
const comands_1 = require("../../../enums/comands");
const message_1 = require("../../../enums/message");
const Run = (code, input, timeout) => {
    (0, shelljs_1.cd)(comands_1.Comands.JavaDir);
    const options = {};
    if (timeout) {
        options.timeout = timeout;
    }
    (0, shelljs_1.exec)(`tsp | echo ${JSON.stringify(code)} > ./main.java && echo ${JSON.stringify(input)} > ./input.txt`);
    const id = (0, shelljs_1.exec)(`tsp javac ./main.java`, options).stdout;
    (0, shelljs_1.exec)(`tsp -c ${id}`, options);
    (0, shelljs_1.exec)(`tsp -k ${id}`);
    if (input) {
        const id_input = (0, shelljs_1.exec)("tsp |  java Main  < input.txt > output.txt", options);
        (0, shelljs_1.exec)(`tsp -c ${id_input}`, options);
        (0, shelljs_1.exec)(`tsp -k ${id_input}`);
        const id_output = (0, shelljs_1.exec)("tsp cat output.txt", options);
        const execute = (0, shelljs_1.exec)(`tsp -c ${id_output}`, options);
        (0, shelljs_1.exec)(`tsp -k ${id_output}`);
        (0, shelljs_1.exec)(`tsp rm -rf /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/*`);
        (0, shelljs_1.exec)(comands_1.Comands.KillFinished);
        (0, shelljs_1.cd)("..");
        return {
            stdout: execute.stdout,
            stderr: execute.stderr,
        };
    }
    else {
        const id_empty = (0, shelljs_1.exec)("tsp java Main", options);
        const execute = (0, shelljs_1.exec)(`tsp -c ${id_empty}`, options);
        (0, shelljs_1.exec)(`tsp -k ${id_empty}`);
        (0, shelljs_1.exec)(`tsp rm -rf /${comands_1.Comands.Dir}/${comands_1.Comands.JavaDir}/*`);
        (0, shelljs_1.exec)(comands_1.Comands.KillFinished);
        (0, shelljs_1.cd)("..");
        return {
            stdout: execute.stdout,
            stderr: execute.stderr,
        };
    }
};
exports.Run = Run;
const Install = () => {
    if (!(0, shelljs_1.which)(comands_1.Comands.Java)) {
        (0, shelljs_1.exec)(comands_1.Comands.JavaInstall);
    }
    if (!(0, shelljs_1.which)(comands_1.Comands.Java)) {
        (0, shelljs_1.echo)(message_1.Message.Java);
    }
    (0, shelljs_1.cd)(`/${comands_1.Comands.Dir}`);
    (0, shelljs_1.exec)(`tsp mkdir -p ${comands_1.Comands.JavaDir}/`);
    (0, shelljs_1.exec)(`tsp touch ${comands_1.Comands.JavaDir}/main.java`);
    (0, shelljs_1.exec)(comands_1.Comands.KillTs);
};
exports.Install = Install;
